/* File name     : camtest1c.c
 * Creation date : April 1992
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Modified date : July 1992, Y.Y
 *               :
 */

/* System headers */
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>

/* Local headers */
#include "camlib.h"

/* Macros */
#define  SWREG  3
#define  MAXLEN 0x1000F

/* File scope variable */

/* External variables */

/* External functions */

/* Structure and unions */

/* Signal catching functions */

/* Functions */
error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
}

/* Main */
main() {
    int status, i, q, x, ii;
    short j, jj;

    printf("camtest1c : test starts\n");
    status = CAM_Open( );
    if( status ) error_exit(status);
    printf("CAM_Open : OK\n");
    status = CSETBR(0);
    if( status ) error_exit(status);
    printf("CSETBR   : OK\n");
    status = CSETCR(0);
    if( status ) error_exit(status);
    printf("CSETCR   : OK\n");
    status = CGENZ();
    if( status ) error_exit(status);
    printf("CGENZ    : OK\n");
    status = CGENC();
    if( status ) error_exit(status);
    printf("CGENC    : OK\n");
    status = CSETI();
    if( status ) error_exit(status);
    printf("CSETI    : OK\n");
    status = CREMI();
    if( status ) error_exit(status);
    printf("CREMI    : OK\n");
    i = 0;
    while (i < 0xFFFF ) {
        status = CAMACW(NAF(SWREG,0,16), &j, &q, &x );
	if( status ) error_exit(status);
        status = CAMACW(NAF(SWREG,0,0), &jj, &q, &x );
        if( status ) error_exit(status);
	if( j != jj || q != 1 || x != 1 ) {
	    printf("Data Comparison Error\n");
	    printf("Written data are %x(h)\n", j);
	    printf("Read data are    %x(h)\n", jj);
	    printf("Q response is    %d\n", q);
	    printf("X response is    %d\n", x);
	    exit(1);
	}
        j++;i++;
    }
    printf("CAMACW   : OK\n");
    while (i < MAXLEN ) {
        status = CAMAC(NAF(SWREG,0,16), &i, &q, &x );
	if( status ) error_exit(status);
        status = CAMAC(NAF(SWREG,0,0), &ii, &q, &x );
        if( status ) error_exit(status);
	if( i != ii ) {
	    printf("Data Comparison Error\n");
	    printf("Written data are %x(h)\n", i);
	    printf("Read data are    %x(h)\n", ii);
	    exit(1);
	}
        i++;
    }
    printf("CAMAC/CAMACL   : OK\n");
    status = CAM_Close();
    if( status ) error_exit(status);
    printf("CAM_Close: OK\n");
}




