/* File name     : camtest2c.c
 * Creation date : April 1992
 * Author        : Y.Yasu, Online group, Physics department, KEK
 * Modified date : July 1992 YY
 *               : adding  output information
 */

/* System headers */
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>

/* Local headers */
#include "camlib.h"

/* Macros */
#define  MEMBUF 4
#define  MAXLOOP 1000
#define  MAXLEN  1000
/* File scope variable */
unsigned short writebuffer[MAXLEN], readbuffer[MAXLEN];

/* External variables */

/* External functions */

/* Structure and unions */
union swaps {
    short shorts[2];
    long longs;
} swaps;

/* Signal catching functions */

/* Functions */
error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
}

/* Main */
main() {
    int status, i, ii, q, x;
    int length, error, return_length;
    int loop;
    short j;
    unsigned long seed=123456789;

    printf("camtest2c : test starts\n");
/* Initialization part */
    status = CAM_Open( );
    if( status ) error_exit(status);
    status = CSETBR(0);
    if( status ) error_exit(status);
    status = CSETCR(0);
    if( status ) error_exit(status);
    status = CGENZ();
    if( status ) error_exit(status);
    status = CGENC();
    if( status ) error_exit(status);
    status = CSETI();
    if( status ) error_exit(status);
    status = CREMI();
    if( status ) error_exit(status);
    return_length = 0;
    error = 0;
    for(i=0; i < MAXLEN; i += 2) {
        seed=seed*663608941;
	swaps.longs = seed;
        writebuffer[i] = swaps.shorts[0];
        writebuffer[i+1] = swaps.shorts[1];
    }
    for(loop = 0; loop < MAXLOOP; loop++ ) {
        status = CAMAC(NAF(MEMBUF,0,9), &i, &q, &x);
        if( status ) error_exit(status);
        status = CDMAW(CC_K_MODES_QIGNR, NAF(MEMBUF,0,16),
		       writebuffer, MAXLEN, &return_length, &error );
        if( status ) error_exit(status);
        status = CAMAC(NAF(MEMBUF,0,9), &i, &q, &x);
        if( status ) error_exit(status);
        for(ii=0; ii < length; ii++)
            readbuffer[ii] = 0;
        status = CDMAW(CC_K_MODES_QIGNR, NAF(MEMBUF,0,0),
		       readbuffer, MAXLEN, &return_length, &error );
        if( status ) error_exit(status);
        for( ii = 0; ii < MAXLEN; ii++) {
            if(writebuffer[ii] != readbuffer[ii] ) {
                printf("error occurred at loop = %d, location = %d\n",
                       loop, ii);
                printf("written data = %x,  read data = %x\n",
                       writebuffer[ii], readbuffer[ii]);
		printf("wb[0] = %x, rb[0] = %x, wb[1] = %x, rb[1] = %x ",
		       writebuffer[0], readbuffer[0],
		       writebuffer[1], readbuffer[1]);
	        printf("wb[2] = %x, rb[2] = %x\n",
		       writebuffer[2], readbuffer[2]);
                exit(1);
	    }
	}
    }
    printf("CDMAW : OK\n");
}
