/* File name     : camtest3c.c
 * Creation date : April 1992
 * Author        : Y.Yasu, Online group, Physics department, KEK
 */

/* System headers */
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
/* Local headers */
#include "camlib.h"

/* Macros */
#define  INTREG 5
#define  MAXLOOP 1000
#define  ENABLE_INTREG (1<<(INTREG-1))
#define  TIME_60_SEC 60

/* File scope variable */

/* External variables */

/* External functions */

/* Structure and unions */

/* Signal catching functions */

/* Functions */
error_exit(status)
int status; {
    perror(strerror(status));
    exit(status);
  }

/* Main */
main() {
    int status, i, q, x;
    short j;
    int loop;

    printf("camtest3c : test starts\n");
/* Initialization part */
    status = CAM_Open( );
    if( status ) error_exit(status);
    status = CSETBR(0);
    if( status ) error_exit(status);
    status = CSETCR(0);
    if( status ) error_exit(status);
    status = CGENZ();
    if( status ) error_exit(status);
    status = CGENC();
    if( status ) error_exit(status);
    status = CSETI();
    if( status ) error_exit(status);
    status = CREMI();
    if( status ) error_exit(status);
    status = CAM_DisableLAM();
    if( status ) error_exit(status);
    printf("CAM_DisableLAM : OK\n");
    status = CAM_EnableLAM(ENABLE_INTREG);
    if( status ) error_exit(status);
    printf("CAM_EnableLAM  : OK\n");
    for(loop = 0; loop < MAXLOOP; loop++ ) {
        status = CAMAC(NAF(INTREG,0,26), &i, &q, &x );
	printf("f=26 : done\n");
        status = CGENC();
	printf("CGENC : done\n");
        status = CAM_WaitLAM(TIME_60_SEC);
	printf("WAITLAM : done\n");
        status = CAMACW(NAF(INTREG,0,24), &i, &q, &x );
	printf("f=24 : done\n");
    }
    printf("CAM_WaitLAM    : OK\n");
    CAM_Close();
}

