/*-----------------------------------------------------------------------------
 * Copyright (c) 1998 Southeastern Universities Research Association,
 *                    Thomas Jefferson National Accelerator Facility
 *
 * This software was developed under a United States Government license
 * described in the NOTICE file included as part of this distribution.
 *
 * TJNAF Data Acquisition Group, 12000 Jefferson Ave., Newport News, VA 23606
 * Email: coda@cebaf.gov  Tel: (757)269-5130  Fax: (757)269-5800
 *-----------------------------------------------------------------------------
 * 
 * Description:
 *   Macros for use with Kinetic Systems 2915 PCI Interface to 3922
 *   Camac Controller with CODA.
 *	
 * Author:  Carl Timmer
 *	    TJNAF Data Acquisition Group
 *
 * Revision History:
 *   $Log: ks2915.h,v $
 *	  Revision 1.1  1998/03/04  10:45:00  timmer
 *	  Initial revision
 *
 */

/* Store and retrieve naf,b,c,n,a information */

#define GETA(ext,a) \
{*a = ((ext)>>5 & 0xf);}
/*{*a = (0x1e0 & (ext));}*/

#define GETN(ext,n) \
{*n = ((ext)>>9 & 0x1f);}
/*{*n = (0x3e00 & (ext));}*/

#define GETC(ext,c) \
{*c = ((ext)>>14 & 0x7);}
/*{*c = (0x1c000 & (ext));}*/

#define GETB(ext,b) \
{*b = ((ext)>>17 & 0x7);}
/*{*b = (0xe0000 & (ext));}*/

#define GETNAF(ext,f,naf) \
{*naf = (0x3fff & (ext) | (f));}

#define CDREG(ext,b,c,n,a) \
{*ext = (0xfffff & (((b)<<17)|((c)<<14)|((n)<<9)|((a)<<5)));}

/* Define function names */

#define cc_open		COPEN
#define cc_close	CCLOSE
#define cc_reset	CRESET
#define cc_ppoll	CPPOLL
#define cc_reg_dump	CREGDUMP

#define cc_set_br	CSETBR
#define cc_set_cr	CSETCR
#define cc_gen_z	CGENZ
#define cc_gen_c	CGENC
#define cc_set_i	CSETI
#define cc_rem_i	CREMI

#define cc_cmd_stat	CCMDSTAT
#define cc_cmd_24	CAMAC
#define cc_cmd_16	CAMACW

#define cc_int_enable	CENINT
#define cc_int_disable	CDISINT
#define cc_lam_enable	CENLAM
#define cc_lam_disable	CDSLAM
#define cc_lam_wait	CWTLAM

#define cc_blkcmd_16	CDMAW
#define cc_blkcmd_24	CDMAL
