#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/time.h>
#include "hsm_conf.h"

int main(int argc, char *argv[])
{
  int      fd, i, j;
  unsigned short buf1[HSM_BLK_SIZE], buf2[HSM_BLK_SIZE];
  struct timeval t1,t2;
  double   dt;

  if ((fd = open("/dev/vmf32d32", O_RDWR)) == -1)
    {puts("! VME device open error."); exit(2);}

  srand(1048577);

  for (j = 0; j < 4; j++) {

    for (i = 0; i < HSM_BLK_SIZE; i++) buf1[i] = rand() & 0xFFFF;

    lseek(fd, (off_t)HSM_MEM_BASE, SEEK_SET);
    gettimeofday(&t1, NULL);
    printf("write = %d", write(fd, buf1, HSM_BLK_SIZE*sizeof(short)));
    gettimeofday(&t2, NULL);
    dt = (t2.tv_sec -t1.tv_sec )*1000.0 + (t2.tv_usec-t1.tv_usec)/1000.0;
    printf(" (%6.3f msec =%6.2f MB/sec)\n",
	   dt, HSM_BLK_SIZE*sizeof(short)/dt/1048.576);
    for (i = 0; i < 32; i++) printf(" %4.4X", buf1[i]); puts("");

    lseek(fd, (off_t)HSM_MEM_BASE, SEEK_SET);
    gettimeofday(&t1, NULL);
    printf("read  = %d", read (fd, buf2, HSM_BLK_SIZE*sizeof(short)));
    gettimeofday(&t2, NULL);
    dt = (t2.tv_sec -t1.tv_sec )*1000.0 + (t2.tv_usec-t1.tv_usec)/1000.0;
    printf(" (%6.3f msec =%6.2f MB/sec)\n",
	   dt, HSM_BLK_SIZE*sizeof(short)/dt/1048.576);
    for (i = 0; i < 32; i++) printf(" %4.4X", buf2[i]); puts("");

    for (i = 0; i < HSM_BLK_SIZE; i += 32) {
      if (memcmp(&(buf1[i]), &(buf2[i]), 32*sizeof(short))) {
	int k;
	printf("buf[%d(%4.4x)]\n", i, i);
	for (k = 0; k < 32; k++) printf(" %4.4X", buf2[i++]); puts("\n");
	goto next;
      }
    }
    puts("memcmp=0\n");

  next:
  }

  close(fd);
  exit(0);
}
